
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>访问者模式（Visitor Pattern） / 憋错料</title>

    <meta name="description" content="访问者模式（Visitor Pattern） 访问者模式:使用一个访问者类,改变元素的行为.通过这种方式,随着访问者的改变,被访问者的行为可以被改变. 类图: 实现Master接口的具体类是行为需要被改变的对象. 实现Visitor接口的具体类是访问者,访问者不同,实现Master接口的具体类的行为不同. public interface Master { public abstract String getName(); } public class ConcreteMaster implements Master { private S">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">访问者模式（Visitor Pattern）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>访问者模式：使用一个访问者类，改变元素的行为。通过这种方式，随着访问者的改变，被访问者的行为可以被改变。</p>
<p>类图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNTY1NC8yMDE2MDYvOTA1NjU0LTIwMTYwNjE2MjIwMzEyMjc2LTY0MTM3MTc0Ny5wbmc=.jpg" /></p>
<p>实现Master接口的具体类是行为需要被改变的对象。</p>
<p>实现Visitor接口的具体类是访问者，访问者不同，实现Master接口的具体类的行为不同。</p>
<pre>public interface Master {
    public abstract String getName();
}

public class ConcreteMaster implements Master {
    private String name;

    public ConcreteMaster(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}

public interface Visitor {
    public abstract void visit(Master master);
}

public class ConcreteVisitor implements Visitor {
    public void visit(Master master) {　　//这里的visit方法仅仅是打印出被访问者的name，改变被访问者的行为的操作就是在这里实现的，不同的Visitor的visit方法不同导致　　　　　　　　　　　　　　　　　　　　　　　　//被访问者的行为也不同
        System.out.println("visit the master " + master.getName());
    }
}</pre>
<pre>public class Test {
    public static void main(String[] args) {
        Master master = new ConcreteMaster("Amy");
        Visitor visitor = new ConcreteVisitor();
        visitor.visit(master);

    }
}</pre>
<p>测试结果：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwNTY1NC8yMDE2MDYvOTA1NjU0LTIwMTYwNjE2MjIwOTQ5NjM1LTIxMjQ5NzQzMzQucG5n.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 20:24:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>访问者模式（Visitor Pattern）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41ydAq4.html" rel="bookmark">访问者模式 Visitor Pattern</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问者模式: 闻词达意,肯定有访问者(对象).接受者(对象).写个实例: 1.IVisitor 抽象访问者角色,声明一个访问操作接口visit(Acceptor ). 2.Visitor 具体访问者角色,实现IVisitor声明的接口. 3.Acceptor 定义一个被访问者,定义接受访问操作(accept(IVisitor)). 4.AcceptorInstance 被访问者实例,实现接受访问操作,然后同意(回调)访问者访问自己. 1 package headfirst.visitor; 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGnJZQ4.html" rel="bookmark">&lbrack;设计模式&rsqb; 23 访问者模式 visitor Pattern</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在GOF的&lt;设计模式:可复用面向对象软件的基础&gt;一书中对访问者模式是这样说的:表示一个作用于某对象结构中的各元素的操作.它使你可以在不改变各元素的类的前提下定义作用于这些元素的新操作.访问者模式把数据结构和作用于结构上的操作之间的耦合解脱开,使得操作集合可以相对自由地演化.该模式的目的是要把处理从数据结构分离出来.访问者模式让增加新的操作很容易,因为增加新的操作就意味着增加一个新的访问者.访问者模式将有关的行为集中到一个访问者对象中.   初次接触,定义会显得晦涩并且难于理解,没关系,LZ来陪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0enXvb3.html" rel="bookmark">设计模式入门之访问者模式Visitor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Set集合的配置 数据表的创建:表关系一个员工拥有多个身份 create table EMPLOYEE ( id INT NOT NULL auto_increment, first_name VARCHAR(20) default NULL, last_name VARCHAR(20) default NULL, salary INT default NULL, PRIMARY KEY (id) ); create table CERTIFICATE ( id INT NOT NULL aut			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgQdKn3.html" rel="bookmark">设计模式之访问者模式&lpar;Visitor&rpar;摘录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				23种GOF设计模式一般分为三大类:创建型模式.结构型模式.行为模式. 创建型模式抽象了实例化过程,它们帮助一个系统独立于如何创建.组合和表示它的那些对象.一个类创建型模式使用继承改变被实例化的类,而一个对象创建型模式将实例化委托给另一个对象.创建型模式有两个不断出现的主旋律.第一,它们都将关于该系统使用哪些具体的类的信息封装起来.第二,它们隐藏了这些类的实例是如何被创建和放在一起的.整个系统关于这些对象所知道的是由抽象类所定义的接口.因此,创建型模式在什么被创建,谁创建它,它是怎样被创建的,以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K6RBrM.html" rel="bookmark">访问者模式 Visitor 行为型 设计模式（二十七）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问者模式 Visitor &lt;侠客行&gt;是当代作家金庸创作的长篇武侠小说,新版电视剧&lt;侠客行&gt;中,开篇有一段独白: “茫茫海外,传说有座侠客岛,岛上赏善罚恶二使,每隔十年必到中原武林,向各大门派下发放赏善罚恶令, 强邀掌门人赴岛喝腊八粥,拒接令者,皆造屠戮,无一幸免,接令而去者,杳无音讯,生死未仆,侠客岛之行,已被视为死亡之旅.” 不过话说电视剧,我总是觉得老版的好看. 意图 表示一个作用于某对象结构中的各元素的操作. 它使你可以在不改变各元素类的前提下定义作用于这些元素的新操作.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPNq2y3.html" rel="bookmark">访问者模式-Visitor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问者模式:表示作用于某对象结构的个元素的操作.它使你在不改变各元素的类的前提下定义作用于这些元素的新操作. 访问者模式的适用场景:有比较稳定的数据结构,又有易于变化的算法的话,使用反复问这模式就是比较合适的,因为访问者模式使得算法操作的增加变得容易. 访问者模式的优缺点: 优点:增加新的操作容易,因为增加新的操作就意味着增加一个新的访问者.访问者模式将有关的行为集中到一个访问者对象中. 缺点:访问者模式使得增加新的数据结构变得苦难了. 访问者模式结构图: 代码实现: 1 package com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35b8D24.html" rel="bookmark">【设计模式】&mdash;&mdash; 访问者模式Visitor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于某个对象或者一组对象,不同的访问者,产生的结果不同,执行操作也不同.此时,就是访问者模式的典型应用了. 应用场景 1 不同的子类,依赖于不同的其他对象 2 需要对一组对象,进行许多不相关的操作,又不想在类中是现在这些方法 3 定义的类很少改变,但是执行的操作却经常发生改变. 回到顶部 模式结构 Context 环境角色 class Context{ List&lt;Node&gt; list = new ArrayList(); public void add(Node node) { list.ad			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wp9AQ4.html" rel="bookmark">设计模式 &lpar; 二十 &rpar; 访问者模式Visitor（对象行为型）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.概述 在软件开发过程中,对于系统中的某些对象,它们存储在同一个集合collection中,且具有不同的类型,而且对于该集合中的对象,可以接受一类称为访问者的对象来访问,而且不同的访问者其访问方式有所不同. 例子1:顾客在超市中将选择的商品,如苹果.图书等放在购物车中,然后到收银员处付款.在购物过程中,顾客需要对这些商品进行访问,以便确认这些商品的质量,之后收银员计算价格时也需要访问购物车内顾客所选择的商品. 此时,购物车作为一个ObjectStructure(对象结构)用于存储各种类型的商品			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a6xZn3.html" rel="bookmark">学习笔记&mdash;&mdash;访问者模式Visitor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问者模式,通过Visitor的注入,为Element扩展了方法实现.虽然避免了Element不用修改即可修改,但却破坏了类的封装性,同时,一旦变更就需要增加子类,在子类方法中调用基类方法,然后再使用Visitor的方法来扩展. 个人理解,Visitor有点类似于策略模式中的算法,都是通过组合的方法变换原有实现.但访问者的变换粒度是具体函数内部要实现扩展,而策略模式主要是算法实现的替换.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rQXmg0.html" rel="bookmark">设计模式&lpar;17&rpar; 访问者模式&lpar;VISITOR&rpar; C&plus;&plus;实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图: 表示一个作用于某对象结构的各元素的操作.它使你可以再不改变各元素的类的前提下定义作用于这些元素的新操作. 动机: 之前在学校的最后一个小项目就是做一个编译器,当时使用的就是访问者模式. 在静态分析阶段,将源程序表示为一个抽象语法树,编译器需要在抽象语法树的基础上实施某些操作以进行静态语义分析.可能需要定义许多操作以进行类型检查.代码优化.流程分析.检查变量是否在使用前被赋值,等等. 这个需求的特点是:要求对不同的节点进行不同的处理. 常规设计方法:不同的节点封装不同的操作. 缺点是,节点			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAggv0.html" rel="bookmark" class="title">第六章&period;解决大问题</a>
					<div>
						用解决小问题的相同方式解决大问题. 1.确认你的软件做客户要它做的事 2.运用基本的OO原则来增加软件的灵活性 3.努力实现可维护.可重用的设计 看待大问题的最佳方式就是化整为零,将它视为许多单独的功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awwKq4.html" rel="bookmark" class="title">HTML5项目笔记1：项目准备和工具使用</a>
					<div>
						公司的 New Case,有需要离线应用工作系统这一块,目标是网络无论在线或离线情况下都可以执行系统操作,这样员工在无网络的情况下依然可以执行公司的项目任务,进行表单填报和数据的客户端保存,并在网络通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8l8A3.html" rel="bookmark" class="title">触发器的应用（商店打折）</a>
					<div>
						--用户信息表create table useres( u_id number(13,0) primary key, username varchar2(50) not null, password  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bDWR4.html" rel="bookmark" class="title">Leetcode -- Day 11</a>
					<div>
						Question 1 Reverse Integer Reverse digits of an integer. Example1: x = 123, return 321Example2: x =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2j1JM.html" rel="bookmark" class="title">十大Intellij IDEA快捷键</a>
					<div>
						Intellij IDEA中有很多快捷键让人爱不释手,stackoverflow上也有一些有趣的讨论.每个人都有自己的最爱,想排出个理想的榜单还真是困难.以前也整理过Intellij的快捷键,这次就按 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEnyX0.html" rel="bookmark" class="title">hdu 2368 Alfredo&amp;&num;39&semi;s Pizza Restaurant（简单数学题）</a>
					<div>
						转载请注明出处:http://blog.csdn.net/u012860063 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2368 题目很简单,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRyVo0.html" rel="bookmark" class="title">vba遗传算法</a>
					<div>
						1 Option Explicit 2 3 '遗传算法参数 4 Dim GeneLength As Integer '染色体长度 5 Dim swarmNum As Integer '种群规模 6 D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQ9z53.html" rel="bookmark" class="title">JAVA实现向文本文件中多次写入数据</a>
					<div>
						使用这种方式,当指定的文件不存在时会自动创建. //此处设置为true即可追加 FileWriter out = new FileWriter(&quot;D:\\1.txt&quot;,true); ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWYArb3.html" rel="bookmark" class="title">浅谈闭包</a>
					<div>
						在刚接触JS面向对象得时候,对闭包是真的不理解,但是在经过多次的查看资料后终于对闭包这个东西有了简单的认识和运用. 首先闭包是指一个函数调用了除其自身以外的变量的时候,就会形成一个闭包.(基本上都是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPD67nM.html" rel="bookmark" class="title">学习ASP&period;NET MVC框架揭秘笔记目录</a>
					<div>
						学习ASP.NET MVC框架揭秘笔记目录 第一章     ASP.NET+MVC 1.1传统的MVC模式 持续更新中,,,,					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKpvn3.html" rel="bookmark" class="title">TCP&sol;IP 原理--链路层</a>
					<div>
						链路层作用: (1)为IP模块发送和接收IP数据报: (2)为ARP发送ARP请求和接受ARP应答 (3)为RARP发送RARP请求和接受ARP应答 协议:以太网和SLIP协议 A.以太网协议数据封装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLdoqM.html" rel="bookmark" class="title">CSS 边框 阴影 效果</a>
					<div>
						下面将css实现阴影效果,以便需要朋友们,直接上代码 #shadow1{width: 200px;height: 100px;color: white; box-shadow: 5px -5px 1p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyZmY3.html" rel="bookmark" class="title">可点击的焦点图</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;title&gt;滑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBAqWM.html" rel="bookmark" class="title">JavaScript 冒泡排序和选择排序</a>
					<div>
						var array = [1,2,3,4,5]; // ---&gt; 服务 //效率 ---&gt; 针对一个有序的数组 效率最高 //标志 true false for(var j = 0; j  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ne6AVM.html" rel="bookmark" class="title">python 函数学习之sys&period;argv&lbrack;1&rsqb;</a>
					<div>
						一.sys 模块 sys是Python的一个「标准库」,也就是官方出的「模块」,是「System」的简写,封装了一些系统的信息和接口. 官方的文档参考:https://docs.python.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxP9dM.html" rel="bookmark" class="title">POJ - 1691 Painting A Board &lpar;状态压缩 ＋ 暴力&rpar;</a>
					<div>
						题目大意:要将一个大矩形內的所有小矩形涂色,涂色要求,只有该矩形上面的所有矩形都涂色了才可以涂该颜色,换一种填涂的颜色就要花费一点体力值,问填涂完需要花费的最小体力值 解题思路:先处理一下填涂该矩形的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvdKNM.html" rel="bookmark" class="title">JavaScript使用方法和技巧大全</a>
					<div>
						有些时候你精通一门语言,但是会发现你其实整天在和其它语言打交道,也许你以为这些微不足道,不至于影响你的开发进度,但恰恰是这些你不重视的东西会浪费你很多时间,我一直以为我早在几年前就已经精通JavaSc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWd8dB0.html" rel="bookmark" class="title">洗纸牌算法</a>
					<div>
						import java.util.Random; class Card { int Suit; //花色 char Number; //牌数 } public class PokeShow { sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDWXqM.html" rel="bookmark" class="title">短学期第二次博客</a>
					<div>
						配置好环境后就要开始编写程序了,我们要做的是一个信息录入系统,可以把个人信息录入到连接的数据库中,并能对其进行增删改查等操作. 配置文件 &lt;!-- 配置SaveAction --&gt;  &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnzpA4.html" rel="bookmark" class="title">python调用C函数</a>
					<div>
						是的,我又开始integrate另一个方法~~ 此方法用C++,Python作胶水,供Matlab调用,原来是在Linux上编译运行,我需要把它在Windows x64上跑起来~~ 在Linux平台, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
